      real function physics_HMS(irun,iread)
      include ?
      real helicity,snorma,pol
      integer irun,irunn
      real halfwave
      real polcal,beampol
      common /HALF/halfwave,polcal,beampol,irunn
      vector charge
      irunn=irun
      beamE=4728
      HMS_mom=2200
      HMS_angle=16.0
      dtime_p0=0.
      dtime_n0=0.
      if( irun.gt.71956  )beampol=1/0.88
      if( irun.gt.72209  )beampol=1/0.88
      if( irun.gt.72300  )beampol=1/0.86
      if( irun.gt.72465  )beampol=1/0.707
      if( irun.gt.72537  )beampol=1/0.73
      if( irun.gt.72767  )beampol=1/0.76
      if( irun.gt.72839  )beampol=1/0.865
      if( irun.gt.72965  )beampol=1/0.88
      if( irun.gt.72977  )beampol=-1/0.66
      halfwave=0
c      write(*,*)half_plate
      halfwave = 1
      halfwave =half_plate 
c      if(
c     ,     (irun.ge.72913.and.irun.le.72925).or.
c     ,     (irun.ge.72956.and.irun.le.72962).or.
c     ,     (irun.ge.72984.and.irun.le.72992).or.
c     ,     (irun.ge.72999.and.irun.le.73011)
c     , )halfwave=1 ! DATABASE - (0) epic =1 (OUT)
c      if(
c     ,     (irun.ge.72926.and.irun.le.72943).or.
c     ,     (irun.ge.72948.and.irun.le.72950).or.
c     ,     (irun.ge.72944.and.irun.le.72947).or.
c     ,     (irun.ge.73012)
c     , )halfwave=-1    !_DATABASE - (1) epic =0 (IN)
      polcal=0
      polcal = polarization
c      if(irun.ge.72913.and.irun.le.72928)polcal =-5.41
c      if(irun.ge.72929.and.irun.le.72936)polcal =-4.8
c      if(irun.ge.72942.and.irun.le.72946)polcal =-5.41
c      if(irun.ge.72947.and.irun.le.72958)polcal =-4.8
c      if(irun.ge.72959.and.irun.le.72961)polcal =-5.41
c      if(irun.ge.72984.and.irun.le.72985)polcal =-2.39
c      if(irun.ge.72986.and.irun.le.72992)polcal =-2.37
c      if(irun.ge.72999.and.irun.le.73012)polcal =-2.39
c      if(irun.ge.73013.and.irun.le.73018)polcal =-2.37
c      if(irun.ge.73019.and.irun.le.73020)polcal =-2.39
c      if(irun.ge.73022.and.irun.le.73025)polcal =-2.37
c      if(irun.ge.73028.and.irun.le.73030)polcal =-2.39
c      if(irun.ge.73031.and.irun.le.73039)polcal =-2.37
      if(iread.eq.1.and.ifirst.eq.0)then
         tcharge_p = charge(1)
         tcharge_n = charge(2)
         acharge_p = charge(3)
         acharge_n = charge(4)
         ifirst=2
      endif
      pol = polarea
      helicity=0   
      if(i_helicity.gt.0)then
         dtime=1-dtime_p!0
         helicity=1.
      else if(i_helicity.lt.0)then
         dtime=1-dtime_n!0
         helicity=-1.
      endif
*      if(dtime_n.ge.1.or.dtime_p.ge.1)goto 10
*      if(dtime_n.le.0.or.dtime_p.le.0)goto 10
      if(charge2s.lt.0.05)goto 10
      if(abs(polcal).gt.100)goto 10
      if(dtime.eq.1)goto 10
      if(dtime.eq.0)goto 10
      if(hel_p_scaler.le.0)goto 10
      if(hel_n_scaler.le.0)goto 10
      if(hel_p_trig.le.0)goto 10
      if(hel_n_trig.le.0)goto 10
c      write(*,*)dtime_p,dtime_n,tcharge,charge2s
      N_p = hel_p_scaler/(1-dtime_p)!0)
      N_n = hel_n_scaler/(1-dtime_n)!0)
      if(i_helicity.gt.0.and.helicity*halfwave.gt.0)then
         charge_p = charge2s*N_p/(float(N_p+N_n))
         charge_n = charge2s*N_n/(float(N_p+N_n))
      elseif(i_helicity.lt.0.and.helicity*halfwave.gt.0)then
         charge_p = charge2s*N_n/(float(N_p+N_n))
         charge_n = charge2s*N_p/(float(N_p+N_n))
      elseif(i_helicity.lt.0.and.helicity*halfwave.lt.0)then
         charge_p = charge2s*N_p/(float(N_p+N_n))
         charge_n = charge2s*N_n/(float(N_p+N_n))
      elseif(i_helicity.gt.0.and.helicity*halfwave.lt.0)then
         charge_p = charge2s*N_n/(float(N_p+N_n))
         charge_n = charge2s*N_p/(float(N_p+N_n))
      endif
         
      if(abs(charge_old_p-tcharge).gt.0.05)then
         charge_old_p= tcharge
         charge_old_n= charge2s
         tcharge_p = tcharge_p+charge_p
         tcharge_n = tcharge_n+charge_n
         acharge_p = acharge_p+charge_p
         acharge_n = acharge_n+charge_n
         
         charge(1) = tcharge_p
         charge(2) = tcharge_n
         charge(3) = acharge_p
         charge(4) = acharge_n
c         write(*,*)charge,tcharge
      endif
c      write(*,*)charge,N_p,N_n,dtime_p,dtime_n
      call HF1(80,helicity*halfwave,1./(1-dtime))
      call HFILL(1012,run,halfwave,1.)
      call HFILL(1013,run,helicity*halfwave,1./(1-dtime))
c      if(n_clust.gt.1)goto 10
c      do i=1,n_clust
         if(
c     ,        cer_h(i).gt.0.and.
c     ,        E_clust(i).gt.1.and.E_clust(i).lt.4.7.and.
     ,         bgtype.eq.1.and.abs(hms_delta).lt.8.
     ,     )then
            E_e=HMS_mom*(1.+hms_delta/100.)
            call Invariants_ep(beamE,E_e,
     &                      HMS_angle,x_b,Q_sq,W_sq,nu)
            Q_sq=Q_sq/1000000.
            W_sq=W_sq/1000000.
            run=irun
            datad=abs(polcal)/100./beampol*halfwave
c            write(*,*)run,datad,beampol,polcal
            call HFILL(1010,run,datad,1.)
            call HFILL(1011,run,abs(polcal)/100.*halfwave,1.)
c         write(18,'(4I13,2F10.5)')bgid,i_helicity,i,cer_h(i),
c     ,           Q2(i),X_Bjorken(i)

c            snorma = float(hel_n_scaler)/float(hel_p_scaler)
            snorma = 1
            call HF1(81,abs(helicity),helicity/snorma)
            call HF1(82,abs(helicity),helicity*snorma)
            call HF1(83,abs(helicity),helicity)
            call HF1(100,Q_sq,1.)
c            x_b=X_Bjorken(i)
c            W= W2(i)
c            if(E_clust(i).gt.2.8.and.w>0.8)then
               call HF2(1000,x_b,sqrt(W_sq),1.)
               call HF1(1005,x_b,1.)
c            endif
            call HF2(1001,x_b,Q_sq,1.)
            call HF2(1002,sqrt(W_sq),Q_sq,1.)
            if(abs(pol).gt.2.and.pol.gt.-1000.)then
               ihistnum=(Q_sq-2.)+1+1+1
c               write(*,*) ihistnum, Q_sq
cc               dtime=0
c               if(btrigtype.ne.4)write(*,*)btrigtype
               if(ihistnum.gt.0.and.ihistnum.le.5)then
                  call fill_hist(ihistnum,X_B,W_sq,pol,helicity,dtime)
               endif     
            endif
         
      endif
c      enddo
 10   continue
      end

      Subroutine fill_hist(ihist,X,W,pol,hel,dtime)
      integer ihist
      real X,pol,hel
      integer irunn
      real halfwave,polcal,beampol
      common /HALF/halfwave,polcal,beampol,irunn

c      write(*,*)halfwave,polcal,beampol
      if(halfwave.ne.0.and.polcal.ne.0)then
      if(polcal.gt.50.and.dtime.lt.0.3)then
c         if(hel*halfwave.gt.0)then
         call HF1(1200,100./polcal*beampol,1)
         if(hel*halfwave.gt.0)then
            call HF1(110+ihist,X,1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(120+ihist,X,1./(1-dtime))
            call HF1(2711,float(irunn),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(2721,float(irunn),1./(1-dtime))
            call HF1(1710+ihist,sqrt(W),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(1720+ihist,sqrt(W),1./(1-dtime))

         elseif(hel*halfwave.lt.0)
            call HF1(130+ihist,X,1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(140+ihist,X,1./(1-dtime))
            call HF1(2712,float(irunn),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(2722,float(irunn),1./(1-dtime))
            call HF1(1730+ihist,sqrt(W),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(1740+ihist,sqrt(W),1./(1-dtime))
         endif

c         else
            if(W.gt.1)then
               call HF1(210+ihist,X, hel*halfwave/
     ,        (polcal/100.)/(1-dtime)*beampol)
               call HF1(220+ihist,X,1./(1-dtime))
               call HF2(2810+ihist,X,W, hel*halfwave/
     ,        (polcal/100.)/(1-dtime)*beampol)
               call HF2(2820+ihist,X,W,1./(1-dtime))
            endif
      else if(polcal.lt.-50.and.dtime.lt.0.3)then
c         if(hel*halfwave.gt.0)then
         call HF1(3400,100./polcal*beampol,1)
         if(hel*halfwave.gt.0)then
            call HF1(310+ihist,X,1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(320+ihist,X,1./(1-dtime))
            call HF1(4711,float(irunn),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(4721,float(irunn),1./(1-dtime))
            call HF1(3710+ihist,sqrt(W),hel*1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(3720+ihist,sqrt(W),1./(1-dtime))
c
         elseif(hel*halfwave.lt.0)then
            call HF1(330+ihist,X,1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(340+ihist,X,1./(1-dtime))
            call HF1(4712,float(irunn),1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(4722,float(irunn),1./(1-dtime))
            call HF1(3730+ihist,sqrt(W),hel*1./
     ,        (polcal/100.)/(1-dtime)*beampol)
            call HF1(3740+ihist,sqrt(W),1./(1-dtime))
         endif
 

         else
            if(W.gt.1)then
               call HF1(410+ihist,X,hel*halfwave/
     ,        (polcal/100.)/(1-dtime)*beampol)
               call HF1(420+ihist,X,1./(1-dtime))
               call HF2(4810+ihist,X,W,hel*halfwave/
     ,        (polcal/100.)/(1-dtime)*beampol)
               call HF2(4820+ihist,X,W,1./(1-dtime))
            endif
         
      endif
      endif
      end

C-- Invariants_ep(in,in,in,out,out,out,out)
C-- E_i = (MeV) Initial electron energy
C-- E_f = (MeV) Final electron energy
C-- theta = (degree) Electron's scattering angle with respect
C--          to the electron beam direction
C-- x_bj = (dim'less) Bjorken x
C-- Q_sq = (MeV^2) Q^2 = -q^2 where q is 4-mom. transfered
C-- W_sq = (MeV^2) W^2 = (P+q)^2 where P is the 4-mom. of nucleon
C-- nu = (MeV) electron's energy loss in the nucleon rest frame
 
      subroutine Invariants_ep(E_i,E_f,theta,x_bj,Q_sq,W_sq,nu)
 
      real E_i,E_f,theta
      real x_bj,Q_sq,W_sq,nu
      parameter (M = 938.272 )
      parameter (d2r = 3.14159/180.)
 
      Q_sq = 4*E_i*E_f*(SIN(theta*d2r/2))**2
      nu = E_i - E_f
      x_bj = Q_sq/(2*M*nu)
      W_sq = M**2 + 2*M*nu - Q_sq
 
      end

